/*
   This Tree is "generic" in a very old fashion way.
   The Tree holds a reference to an Object, so it
   can hold anything, but there is no way to force
   the tree to hold only one kind of object.

   This is very much like a C tree that holds
   "pointers to void", void*.
*/
public class Tree
{
   public Object data;
   public Tree left;
   public Tree right;

   public Tree(Object data) {
      this(data, null, null);
   }

   public Tree(Object data, Tree left, Tree right) {
      this.data = data;
      this.left = left;
      this.right = right;
   }

   public int depth() {
      int result = 1;
      if (null != left) {
         result = left.depth();
      }
      if (null != right) {
         result = Math.max(result, right.depth());
      }
      return result;
   }

   public int size() {
      int result = 1;
      if (null != left) {
         result += left.size();
      }
      if (null != right) {
         result += right.size();
      }
      return result;
   }
}
