/*

*/
class Tree<T>
{
   private BTree<T> btree;

   private Tree()
   {
      btree = null;
   }

   public Tree(T data) {
      btree = new BTree<T>(data, null, null);
   }

   public Tree(T data, Tree<T> left, Tree<T> right) {
      btree = new BTree<T>(data, left.btree, right.btree);
   }

   public T root() {
      return btree.root();
   }

   public Tree<T> left() {
      Tree<T> temp = new Tree<T>();
      temp.btree = this.btree.left();
      return temp;
   }

   public Tree<T> right() {
      Tree<T> temp = new Tree<T>();
      temp.btree = this.btree.right();
      return temp;
   }

   public int depth() {
      return btree.depth();
   }

   public int size() {
      return btree.size();
   }

   public String toString() {
      return btree.toString();
   }
}

class BTree<T>
{
   private T data;
   private BTree<T> left;
   private BTree<T> right;

   public BTree(T data) {
      this(data, null, null);
   }

   public BTree(T data, BTree<T> left, BTree<T> right) {
      if (null == data)
         throw new IllegalArgumentException();

      this.data = data;
      this.left = left;
      this.right = right;
   }

   public T root() {
      return data;
   }

   public Tree<T> left() {
      return left;
   }

   public Tree<T> right() {
      return right;
   }

   public int depth() {
      int result = 1;
      if (null != left) {
         result = left.depth();
      }
      if (null != right) {
         result = Math.max(result, right.depth());
      }
      return result;
   }

   public int size() {
      int result = 1;
      if (null != left) {
         result += left.size();
      }
      if (null != right) {
         result += right.size();
      }
      return result;
   }

   public String toString() {
      String result = "(" + data;
      result += ", ";
      result += left;  // recursion
      result += ", ";
      result += right; // recursion
      result += ")";
      return result;
   }
}
