/*
This implementation of the Tree interface
represents a non-empty Tree.

It enforces a rule that non of the references
in a Tree object can be null references.

These trees are immutable. There is no way
to change them once they are constructed.
*/
public class Tree_Node<T> implements Tree<T>
{
   private T data;
   private Tree<T> left;
   private Tree<T> right;

   public Tree_Node(T data, Tree<T> left, Tree<T> right) {
      if (null == data || null == left || null == right)
         throw new IllegalArgumentException();

      this.data = data;
      this.left = left;
      this.right = right;
   }

   public int depth() {
      return 1 + Math.max(left.depth(), right.depth());
   }

   public int size() {
      return 1 + left.size() + right.size();
   }
}
