public class Tree_Node<T> implements Tree<T>
{
   private T data;
   private Tree<T> left;
   private Tree<T> right;

   public Tree_Node(T data, Tree<T> left, Tree<T> right) {
      if (null == data || null == left || null == right)
         throw new IllegalArgumentException();

      this.data = data;
      this.left = left;
      this.right = right;
   }

   public int depth() {
      return 1 + Math.max(left.depth(), right.depth());
   }

   public int size() {
      return 1 + left.size() + right.size();
   }

   public void addLeft(Tree<T> left) {
      if (null == left)
         throw new IllegalArgumentException();

      if ( ! (left instanceof Tree_Nil) )
         throw new UnsupportedOperationException();

      this.left = left;
   }

   public void addRight(Tree<T> right) {
      if (null == right)
         throw new IllegalArgumentException();

      if ( ! (right instanceof Tree_Nil) )
         throw new UnsupportedOperationException();

      this.right = right;
   }

}
